from __future__ import division
import numpy as np

def calc_julia(int im_width, int im_height, int xmin, int xmax, int ymin, int ymax, double zabs_max, int nit_max, complex c):
    cdef double xwidth = xmax - xmin
    cdef double yheight = ymax - ymin

    julia = np.zeros((im_width, im_height))
    
    for ix in range(im_width):
        for iy in range(im_height):
            nit = 0
            # Map pixel position to a point in the complex plane
            z = complex(ix / im_width * xwidth + xmin,
                        iy / im_height * yheight + ymin)
            # Do the iterations
            while abs(z) <= zabs_max and nit < nit_max:
                z = z**2 + c
                nit += 1
            
            ratio = nit / nit_max
            julia[ix,iy] = ratio
    return julia
