#!/usr/bin/env python
from __future__ import division
import numpy as np

def calc_julia(im_width, im_height, xmin, xmax, ymin, ymax, zabs_max, nit_max,c):
    xwidth = xmax - xmin
    yheight = ymax - ymin
    julia = np.zeros((im_width, im_height))
    
    for ix in range(im_width):
        for iy in range(im_height):
            nit = 0
            # Map pixel position to a point in the complex plane
            z = complex(ix / im_width * xwidth + xmin,
                        iy / im_height * yheight + ymin)
            # Do the iterations
            while abs(z) <= zabs_max and nit < nit_max:
                z = z**2 + c
                nit += 1
            shade = 1-np.sqrt(nit / float(nit_max))
            ratio = nit / nit_max
            julia[ix,iy] = ratio
    return julia
